<?php
require_once "inc/usuario.php";

date_default_timezone_set('America/Sao_Paulo');

if(!isset($_SESSION)) {
  session_start();
}


if ($_SERVER['REQUEST_METHOD'] == 'POST') {
  require_once 'inc/lancamento_inventario.php';
  // $redirect = 'erpc_lancamento_inventario_list.php';

  $redirect = 'erpc_armazens_locais_lancar_inventario_list.php';
  $lancamento_inventario = ler_lancamento_inventario();

  // capturando o usuário e unidade logado
  $usuario_pedido = getLoggedUser();
  $lancamento_inventario['id_usuario']=$usuario_pedido['id'];
  // $lancamento_inventario['id_unidade']=$usuario_pedido['unidade'];
  

  /* 19/03/2018 Inclusão do campo vl_pagamento, */
  // if(!isset($lancamento_inventario['vl_pagamento'])){
  //   $lancamento_inventario['vl_pagamento']  = $lancamento_inventario['vl_total_pedido'];
  // }
  
  // echo "<pre>";
  // print_r($lancamento_inventario);
  // echo "</pre>";
  // exit;
  
  if (isset($_POST['btn-add'])) {
    $ok = lancamento_inventario_insert($lancamento_inventario);
    if ($ok === false) {
      $redirect = 'erpc_armazens_locais_lancar_inventario_list.php';
    }
  } else if (isset($_POST['btn-edit']) or isset($_POST['btn-processar'])) {
    /*
    $lancamento_inventario['id'] = $_POST['id'];
    
    $ok = lancamento_inventario_update($lancamento_inventario);
    if ($ok === false) {
      $redirect = 'erpc_armazens_locais_lancar_inventario_add.php?id=' . urlencode(base64_encode($lancamento_inventario['id']));
    }
    */
    $inventario = $_POST['lancamento_inventario'];
    $nr_documento = $inventario['ds_documento'];
    $dt_entrada = $inventario['dt_entrada'];
    $ds_documento = $inventario['ds_documento'];
    $id_local_estoque = $inventario['id_local_estoque'];
    $id_usuario = $usuario_pedido['id'];
    
    if(count($inventario['itens']) > 0){
        foreach($inventario['itens'] as $item){
            $id_produto = $item['id_produto'];
            $vl_saldo_enderecar = $item['vl_saldo_enderecar'];
            if(!empty($vl_saldo_enderecar)){
                $sql_insert_update = "insert into erpc_saldos_enderecar
                                          (   id_produto        , vl_saldo_enderecar, dh_alteracao , st_ativo
                                            , id_local_estoque  , ds_documento      , dt_entrada   , id_usuario   )
                                    values
                                     ( $id_produto       , $vl_saldo_enderecar, now(), 1
                                     ,$id_local_estoque , '$ds_documento'      , str_to_date('$dt_entrada', '%d/%m/%Y'), $id_usuario)
                                    ON DUPLICATE KEY UPDATE
                                         vl_saldo_enderecar = $vl_saldo_enderecar
                                        ,dh_alteracao = now()
                                        ,dt_entrada = str_to_date('$dt_entrada', '%d/%m/%Y')
                                        ,id_usuario = $id_usuario ;";
                mysqli_query($conexao, $sql_insert_update) or die(mysqli_error($conexao) . "<br><br>$sql_insert_update");
            }
        }
        if(isset($_POST['btn-processar'])){
            
            foreach($inventario['itens'] as $item){
                $id_produto = $item['id_produto'];
                $vl_saldo_enderecar = $item['vl_saldo_enderecar'];
                if(!empty($vl_saldo_enderecar)){
                    $sql_insert_update = "insert into erpc_produtos_saldos
                                          (   id_produto, id_local, vl_saldo )
                                    values
                                     ( $id_produto, $id_local_estoque, $vl_saldo_enderecar )
                                    ON DUPLICATE KEY UPDATE
                                         vl_saldo = $vl_saldo_enderecar;";
                    mysqli_query($conexao, $sql_insert_update) or die(mysqli_error($conexao));
                }
            }
            $sql_status_processado = "update erpc_saldos_enderecar set dt_processado = now() where ds_documento = '$ds_documento'";
            mysqli_query($conexao, $sql_status_processado) or die(mysqli_error($conexao));
        }
    }
    
      
  } else if (isset($_POST['btn-remove'])) {
    $lancamento_inventario['id'] = $_POST['id'];
    $ok = lancamento_inventario_delete($lancamento_inventario);
    if ($ok === false) {
      $redirect = 'erpc_armazens_locais_remove.php?id=' . urlencode(base64_encode($lancamento_inventario['id']));
    }
  }else if (isset($_POST['btn-confirmar-alteracao-status'])) {
    $lancamento_inventario['id'] = $_POST['id'];
    $lancamento_inventario['st_bloq'] = $_POST['st_bloq']==true?'false':'true';
    $ok = lancamento_inventario_alterar_status($lancamento_inventario);
    if ($ok === false) {
      $redirect = 'erpc_armazens_locais_list.php';
    }
  } 
  // else if (isset($_POST['btn-confirmar-impressao-etiquetas'])) {
  //   $lancamento_inventario['id'] = $_POST['id'];

  //   // $ok = lancamento_inventario_alterar_status($lancamento_inventario);
  //    $redirect = 'erpc_armazens_impressao.php';
  // }
  header("Location:$redirect");
  exit;
}

function ler_lancamento_inventario() {
  date_default_timezone_get('America/Sao_Paulo');
  $lancamento_inventario = lancamento_inventario_create();

  if (isset($_POST['lancamento_inventario'])) {
    $lancamento_inventario = array_replace_recursive($lancamento_inventario, $_POST['lancamento_inventario']);
  }
 
  foreach($lancamento_inventario as $k => $v) {
    $lancamento_inventario[$k] = sgcws_sanitize_field($k, $v);

    //  echo "<br> $key ==> $v";
  }
    
  $itens = $lancamento_inventario['itens'];
  foreach($itens as $i => $item) {
    foreach($item as $k => $v) {
      $item[$k] = sgcws_sanitize_field($k, $v);
    }
    $itens[$i] = $item;
  }
  $lancamento_inventario['itens'] = $itens;

return $lancamento_inventario;
}
  